!c Description:
!c   絤ʳؤνʪ̤η׻
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-06-02    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

program OboroAtmos
  use gtool_history
  use prm_common, only: obrinit, property, AdbtFile, grav, smax, emax
  use interface_netcdf_open
  use interface_netcdf_get
  use interface_netcdf_close
  use interface_molweight
  use interface_cp_noblegas
  use interface_cp_spl
  use interface_lapserate
  use interface_clouddensity

  implicit none
  real(8), allocatable        :: pres(:)       !
  real(8), allocatable        :: entr(:)       !ȥԡ
  real(8), allocatable        :: temp(:)       !
  real(8), allocatable        :: vtemp(:)      !
  real(8), allocatable        :: mol(:,:)      !ؼΥ
  real(8), allocatable        :: emol(:,:)     !ǤΥ
  real(8), allocatable        :: molfr(:,:)    !ؼΥ 
  real(8), allocatable        :: mu(:,:)       !إݥƥ󥷥
  real(8), allocatable        :: molwt(:)      !ʬ
  real(8), allocatable        :: molwt_dry(:)  !絤ʬ
  real(8), allocatable        :: dtdz(:)       !ٸΨ
  real(8), allocatable        :: dtdz_dry(:)   !絤βٸΨ
  real(8), allocatable        :: vdtdz(:)      !ٸΨ
  real(8), allocatable        :: vdtdz_dry(:)  !絤βٸΨ
  real(8), allocatable        :: stab(:)       !Ū
  real(8), allocatable        :: vstab(:)      !٤ǤŪ
  real(8), allocatable        :: cp(:)         !Ǯ
  real(8), allocatable        :: cp_dry(:)     !絤Ǯ
  real(8), allocatable        :: cp_tmp(:,:)   !Ǯ()
  real(8), allocatable        :: cldns(:,:)    !̩
  real(8), allocatable        :: mu_tmp(:,:)
  real(8), allocatable        :: mol_tmp(:,:)
  real(8), allocatable        :: molfr_tmp(:,:)
  real(8), allocatable        :: emol_tmp(:,:)
  integer                     :: smax_gas      !βؼο
  integer                     :: num           !ֹ
  integer                     :: snum          !ؼֹ
  integer                     :: step          !׻ƥå׿
  integer                     :: ncid
  character(10)               :: name          !̾

  
!!!
!!!ǡƤӽФ
!!!
  call obrinit


!!!
!!!NetCDF եΥץ
!!! pres, spc, elm Ǥ뤳ȤΤäƤ
!!!
  !եΥץ
  call netcdf_open(trim(AdbtFile), ncid)

  !ѿμ. Фѿ pres, spc, elm, temp, mol, molfr 
  name = 'pres'
  call netcdf_get(ncid, name, pres)
  name = 'temp'
  call netcdf_get(ncid, name, temp)
  name = 'entr'
  call netcdf_get(ncid, name, entr)
!  name = 'mu'
!  call netcdf_get(ncid, name, mu_tmp)
  name = 'mol'
  call netcdf_get(ncid, name, mol_tmp)
  name = 'molfr'
  call netcdf_get(ncid, name, molfr_tmp)
  name = 'emol'
  call netcdf_get(ncid, name, emol_tmp) 

  !γ
  step = size(pres)
  allocate(mu(step, smax), &
       & mol(step, smax), &
       & molfr(step, smax), &       
       & emol(step, emax))
!  mu    = transpose(mu_tmp)
  mol   = transpose(mol_tmp)
  molfr = transpose(molfr_tmp)
  emol  = transpose(emol_tmp)

  !եĤ
  call netcdf_close(ncid)
  
  
!!!
!!!γ
!!!
  smax_gas = count(property%phase == 1)
  allocate(molwt(step), &
       & molwt_dry(step), &
       & vtemp(step), &
       & dtdz(step), &
       & vdtdz(step), &
       & dtdz_dry(step), &
       & vdtdz_dry(step), &
       & stab(step), &
       & vstab(step), &
       & cp(step), &
       & cp_dry(step), &
       & cp_tmp(step, smax_gas))

  
!!!
!!!ʬ̤η׻. 絤ʬ̤絤ǾؤǤʬ̤Ȥ. 
!!!
  !ʬ
  do num = 1, step 
     call molweight(molfr(num, :), property, molwt(num))
  end do
  
  !絤ʬ
  molwt_dry = molwt(step)
  
  
!!!
!!!Ǯη׻. 絤Ǯ絤ǾؤǤʬ̤Ȥ. 
!!!
  !Ǯ
  do num = 1, step
     do snum = 1, smax
        if (property(snum)%method == 1) then 
           call cp_noblegas(temp(num), cp=cp_tmp(num, snum))
        elseif (property(snum)%method == 2) then
           call cp_spl(temp(num), property(snum), cp=cp_tmp(num, snum))
        end if
     end do
     
     cp(num) = dot_product(molfr(num, 1: smax_gas), cp_tmp(num,:))
  end do
  
  !絤Ǯ. Ǯϲ()¸, ϰ. 
  do num = 1, step   
     cp_dry(num) = &
          & dot_product(molfr(step, 1: smax_gas), cp_tmp(num, 1: smax_gas))
  end do
  
  
!!!
!!!٤η׻
!!!
  vtemp = temp * (molwt_dry / molwt)
  
  
!!!
!!!ٸΨη׻
!!!
  !٤θΨ
  call lapserate(temp, pres, grav, molwt, dtdz)
  
  !٤θΨ
  call lapserate(vtemp, pres, grav, molwt_dry, vdtdz)
  
  
!!!
!!!絤ǮٸΨ
!!!
  !ٸΨ
  dtdz_dry = grav * molwt / cp
  
  !ٸΨ
  vdtdz_dry = grav * molwt_dry / cp_dry 
  
  
!!!
!!!Ū
!!!
  !Ū
  stab = - (grav * (dtdz - dtdz_dry) * 1.0D-3) / temp
  
  !٤ǤŪ
  vstab = - (grav * (vdtdz - vdtdz_dry) * 1.0D-3) / temp
  
!!!
!!!
!!!
  call clouddensity(temp, pres, property, molfr, cldns)
  
  
!!!
!!!NetCDF եѰ
!!!
  call output_gtool4_init


!!!
!!!ʪ̤ν񤭽Ф
!!!
  call HistoryPut('entr', entr)
  call HistoryPut('temp', temp)
  call HistoryPut('vtemp', vtemp)
  call HistoryPut('mol', mol)
  call HistoryPut('emol', emol)
  call HistoryPut('molfr', molfr)
!  call HistoryPut('mu', mu)
  call HistoryPut('molwt', molwt)
  call HistoryPut('molwt_dry', molwt_dry)
  call HistoryPut('dtdz', dtdz)
  call HistoryPut('dtdz_dry', dtdz_dry)
  call HistoryPut('vdtdz', vdtdz)
  call HistoryPut('vdtdz_dry', vdtdz_dry)
  call HistoryPut('stab', stab)
  call HistoryPut('vstab', vstab)
  call HistoryPut('cp', cp)
  call HistoryPut('cldns', cldns)
  

!!!
!!!NetCDF եĤ
!!!
  call HistoryClose


contains

  subroutine output_gtool4_init
    use prm_common, only: planet, AtmosFile
    
    implicit none
    real(8)                 :: spc(smax)
    real(8)                 :: elm(emax)
    integer                 :: num  
    integer                 :: i 
    character(1000)         :: dataset
    
    !ե˽񤭽Ф٤ͤѿ
    write(dataset, *) planet, "; pres_ini=", pres(1), &
         & "; pres_end=", pres(step), &
         & "; temp_ini=", temp(1), &
         & "; step=", step, ";  ", property%name
    num = len_trim(dataset)
    
    !°, ɸ
    call HistoryCreate(&
         & file=AtmosFile, &
         & title="Equilibrium Calculation", &
         & source=dataset(:num+1), &
         & institution="GFD_Dennou_Club oboro Project", &
         & dims=(/'pres', 'spc ', 'elm '/), &
         & dimsizes=(/int(step, 4), int(smax, 4), int(emax, 4)/), &
         & longnames=(/"Pressure        ", "chemical species", "element         "/), &
         & units=(/"Pa", "1 ", "1 "/), &
         & origin=0.0,  &
         & interval=0.0)
    
    !
    spc = (/(i, i = 1, smax)/)
    call HistoryPut('spc', real(spc, 4))

    elm = (/(i, i = 1, emax)/)
    call HistoryPut('elm', real(elm, 4))
    
    call HistoryPut('pres', real(pres, 4))
    

    !ѿ, ȥԡ
    call HistoryAddVariable( &
         & varname="entr", &
         & dims=(/'pres'/), &
         & longname="Entropy", &
         & units='J', &
         & xtype="double" )
    
    !ѿ, 
    call HistoryAddVariable( &
         & varname="temp", &
         & dims=(/'pres'/), &
         & longname="Temperature", &
         & units='K', &
         & xtype="double" )
    
    !ѿ, 
    call HistoryAddVariable( &
         & varname="vtemp", &
         & dims=(/'pres'/), &
         & longname="Vertial Temperature", &
         & units='K', &
         & xtype="double" )
    
    !ѿ, 
    call HistoryAddVariable( &
         & varname="mol", &           
         & dims=(/'pres', 'spc '/), &
         & longname="Chemical Species Abundance", &
         & units='mol', &
         & xtype="double" )

    !ѿ, 
    call HistoryAddVariable( &
         & varname="emol", &           
         & dims=(/'pres', 'elm '/), &
         & longname="Element Abundance", &
         & units='mol', &
         & xtype="double" )

    !ѿ, 
    call HistoryAddVariable( &
         & varname="molfr", &           
         & dims=(/'pres', 'spc '/), &
         & longname="Mol Fraction", &
         & units='1', &
         & xtype="double" )

    !ѿ, إݥƥ󥷥
    call HistoryAddVariable( &
         & varname="mu", &           
         & dims=(/'pres', 'spc '/), &
         & longname="Chemical Potential", &
         & units='J/Kg', &
         & xtype="double" )

    !ѿ, 絤ʬ
    call HistoryAddVariable( &
         & varname="molwt", &           
         & dims=(/'pres'/), &
         & longname="Atmospheric Mol Weight", &
         & units='g/mol', &
         & xtype="double" )

    !ѿ, 絤ʬ
    call HistoryAddVariable( &
         & varname="molwt_dry", &           
         & dims=(/'pres'/), &
         & longname="Atmospheric Mol Weight", &
         & units='g/mol', &
         & xtype="double" )

    !ѿ, ٸΨ
    call HistoryAddVariable( &
         & varname="dtdz", &           
         & dims=(/'pres'/), &
         & longname="Lapse Rate", &
         & units='K/km', &
         & xtype="double" )

    !ѿ, 絤βٸΨ
    call HistoryAddVariable( &
         & varname="dtdz_dry", &           
         & dims=(/'pres'/), &
         & longname="Dry Lapse Rate", &
         & units='K/km', &
         & xtype="double" )

    !ѿ, ٸΨ
    call HistoryAddVariable( &
         & varname="vdtdz", &           
         & dims=(/'pres'/), &
         & longname="Lapse Rate", &
         & units='K/km', &
         & xtype="double" )

    !ѿ, 絤βٸΨ
    call HistoryAddVariable( &
         & varname="vdtdz_dry", &           
         & dims=(/'pres'/), &
         & longname="Dry Lapse Rate", &
         & units='K/km', &
         & xtype="double" )

    !ѿ, Ū
    call HistoryAddVariable( &
         & varname="stab", &           
         & dims=(/'pres'/), &
         & longname="Stability", &
         & units='s^-2', &
         & xtype="double" )

    !ѿ, Ū
    call HistoryAddVariable( &
         & varname="vstab", &           
         & dims=(/'pres'/), &
         & longname="Stability", &
         & units='s^-2', &
         & xtype="double" )

    !ѿ, Ǯ
    call HistoryAddVariable( &
         & varname="cp", &           
         & dims=(/'pres'/), &
         & longname="Specific Heat", &
         & units='J/ k mol', &
         & xtype="double" )

    !ѿ, ̩
    call HistoryAddVariable( &
         & varname="cldns", &           
         & dims=(/'pres', 'spc '/), &
         & longname="Cloud Density", &
         & units='g/l', &
         & xtype="double" )

  end subroutine output_gtool4_init
  
end program OboroAtmos


